#include <iostream>
#include <fstream>
#include <stdlib.h>
#include <string>
#include <windows.h>

unsigned char rawWBOR[16] = {
	0x57, 0x42, 0x4F, 0x52, 0x6E, 0x00, 0x00, 0x00, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 
	} ;
	
unsigned char rawBblock[8] = {
	0x57, 0x42, 0x4F, 0x52, 0x6E, 0x00, 0x00, 0x00, 
	} ;

int main(int argc, char** argv) {
		
     std::string wvFileName=argv[1]; 
     char Path[MAX_PATH];
     std::string getDrivePath;
     std::string massexportEx;
     std::string checktype;
     HWND hwnd;
     
     GetModuleFileName(NULL, Path, MAX_PATH);
     getDrivePath=Path;
     int truncate_path = getDrivePath.find_last_of("\\");
     getDrivePath.erase(truncate_path+1); 
    
     massexportEx=getDrivePath;   
     
///////////////////////////////////////////////////////////////////

         int imaType=3;
         std::string wavname;
         std::string curdirect;
        
         unsigned char balign, nuchan;
         unsigned long samp_rate;
         unsigned long wvformat;
         short PcmBlockSize;

         FILE *ReadWav;
         
         ReadWav = fopen(wvFileName.c_str(), "rb");
         
         fseek(ReadWav,0x10,SEEK_SET);
         fread(&wvformat, sizeof (unsigned long), 1, ReadWav);
         fseek(ReadWav, 2, SEEK_CUR);
         fread(&nuchan, sizeof (unsigned char), 1, ReadWav);
         fseek(ReadWav, 1, SEEK_CUR);
         fread(&samp_rate, sizeof (unsigned long), 1, ReadWav);
         fseek(ReadWav, 4, SEEK_CUR);
         fread(&PcmBlockSize, sizeof( short), 1, ReadWav);

          checktype=wvFileName; // is this a wave?
          int savext = checktype.find_last_of(".");
          checktype.erase(0, savext+1);   //keep file extension         
         
         //standard pcm wav
         if(wvformat==16 ){
           imaType = 0;
           }
         
         //ima/dvi adpcm, with compatible block alignment -
         if(wvformat==20 && PcmBlockSize==1028 || wvformat==20 &&
           PcmBlockSize==2056){
           imaType = 1; 
          }
          
         // correct wav type, incorrect block alignment -
         if(wvformat==20 && imaType==0){
          imaType = 2;
           }
           
         if(checktype!="wav") // this is not a wave file!
           {
           	imaType=4;
           }  

 ///////////////////////////////////////////////////////////////

          if(wavname.length()>0){
            wavname.erase();
            }       
           
        if(imaType==0 || imaType==1){ 
          unsigned long wavSample;
          unsigned char wavChannel;
          std::string curdirect;
          
          wavname=wvFileName;   //open .wav
          curdirect=wvFileName; //hold .cau

          
          int extname = wavname.rfind("\\");
          wavname.erase(0, extname+1);
          int lstrip = wavname.find(".");
          wavname.erase(lstrip,4);
          
          curdirect=massexportEx;
          curdirect+=wavname;
          curdirect+=".cau";
                
          

 /////////////////////////////////////////////////////////////////

              char* linea_buf;
              FILE *capFile;

              BOOL bExitFired=FALSE;
              BOOL bShowMsgBox=FALSE;
           
 ///////////////////////////////////////////////////////////////////
 
         FILE *cauout, *wavFile;
         
         cauout = fopen(curdirect.c_str(), "wb");
         
         wavFile = fopen(wvFileName.c_str(), "rb");
         
         unsigned long wavLength;
         unsigned long imaLength;
         unsigned long pcmLength;
         unsigned long noCaption=0x24;
         unsigned long fourzeros=0x00;
         unsigned char tenval;
         unsigned char sixval=16;
         unsigned char iselvn=14;
         unsigned char oneval=1;
         unsigned char iszero=0;
         unsigned long oneChar;
         unsigned char addChar;
         unsigned char imaOne;
         unsigned char imaTwo;
         
         fseek(wavFile, 0x20, SEEK_SET);
         fread(&imaOne, sizeof(unsigned char),  1, wavFile);
         fread(&imaTwo, sizeof(unsigned char),  1, wavFile);
         
         fread(&tenval,   sizeof(unsigned char), 1, wavFile);
         
         fseek(wavFile, 0x16, SEEK_SET); //number of channels
         fread(&wavChannel, sizeof(unsigned char),1,wavFile);
         
         fseek(wavFile, 1, SEEK_CUR);  // sample rate for wav
         fread(&wavSample, sizeof(unsigned long), 1,wavFile);
         
         fseek(wavFile, 0x28, SEEK_SET); // actual wav length
         fread(&wavLength, sizeof(unsigned long), 1,wavFile);
         
         if(imaType==1){
         fseek(wavFile, 4, SEEK_CUR);
         fread(&imaLength, sizeof(unsigned long),1, wavFile);
         fseek(wavFile, 4, SEEK_CUR);
         fread(&pcmLength, sizeof(unsigned long),1, wavFile);
          }
         
         if(imaType==0){
         
         fwrite(&rawWBOR ,sizeof(unsigned char), 16, cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1,cauout);
         fwrite(&wavLength, sizeof(unsigned long), 1,cauout);
         fwrite(&wavSample, sizeof(unsigned long), 1,cauout);
         fwrite(&tenval,  sizeof(unsigned char),   1,cauout);
         fwrite(&wavChannel,sizeof(unsigned char), 1,cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1,cauout);
         fwrite(&iszero,  sizeof(unsigned char),   1,cauout);
         fwrite(&fourzeros, sizeof(unsigned long),1, cauout);
         }
          
         if(imaType==1){
         fwrite(&rawBblock, sizeof(unsigned char), 8,cauout);
         fwrite(&noCaption, sizeof(unsigned long), 1,cauout);
         fwrite(&imaOne,   sizeof(unsigned char), 1, cauout);
         fwrite(&imaTwo,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&iszero,   sizeof(unsigned char), 1, cauout);
         fwrite(&pcmLength, sizeof(unsigned long),1, cauout);
         fwrite(&imaLength, sizeof(unsigned long),1, cauout);
         fwrite(&wavSample, sizeof(unsigned long),1, cauout);
         fwrite(&sixval,   sizeof(unsigned char), 1, cauout);
         fwrite(&wavChannel, sizeof(unsigned char),1,cauout);
         fwrite(&oneval, sizeof(unsigned char),  1,  cauout);
         fwrite(&iszero, sizeof(unsigned char),  1,  cauout);
         fwrite(&fourzeros, sizeof(unsigned long), 1,cauout);
         
         wavLength=0;
         wavLength=pcmLength;
          }
          
         int longCount=0;

         for(int z=0; z<wavLength/4; z++){ // write out dat
         ++longCount;
         fread(&oneChar, sizeof(unsigned long), 1, wavFile);
         fwrite(&oneChar,sizeof(unsigned long), 1,  cauout);
          }
         
         longCount=longCount*4;
         
         while (longCount<wavLength){ // write out any stray
          ++longCount;
         fread(&addChar, sizeof(unsigned char), 1, wavFile);
         fwrite(&addChar, sizeof(unsigned char), 1, cauout);
         }
         
         if(linea_buf>0){
         GlobalFree((HANDLE)linea_buf);
         }
         
         fclose(cauout);
         fclose(wavFile);
        } 
         
         if(imaType==2){
          MessageBox(NULL, "Incorrect block alignment (no .cau file"
          " exported).  Selected .wav incompatible with Trespasser.",
          "Create_Cau - Error",MB_OK);
           }
         if(imaType==3){
          MessageBox(NULL, "Incorrect adpcm .wav type (no .cau file"
          " exported).  Selected .wav incompatible with Trespasser.",
          "Create_Cau - Error",MB_OK);
           }    

         if(imaType==4){
          MessageBox(NULL, "No .cau file created. Dropped file was not"
		  " a wave file!", "Create_Cau - Error",MB_OK);
          
           }   
 /////////////////////////////////////////////////////////////////////
	return 0;
}
